"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.render = exports.ID = void 0;
const react_1 = __importStar(require("react"));
const react_dom_1 = __importDefault(require("react-dom"));
const server_1 = __importDefault(require("react-dom/server"));
const core_1 = require("@blueprintjs/core");
const util_1 = require("./util");
const ImagePreview = () => {
    const [src, setSrc] = react_1.useState("");
    const onDialogClose = react_1.useCallback(() => setSrc(""), [setSrc]);
    const onRootClick = react_1.useCallback((e) => {
        const target = e.target;
        if (target.tagName === "IMG" &&
            target.classList.contains("roamjs-image-preview-img")) {
            setSrc(target.src);
        }
    }, [setSrc]);
    react_1.useEffect(() => {
        document.body.addEventListener("click", onRootClick);
    }, [onRootClick]);
    const imageRef = react_1.useRef(null);
    const [height, setHeight] = react_1.useState('100%');
    const [width, setWidth] = react_1.useState('100%');
    react_1.useEffect(() => {
        const dummyImage = new Image();
        dummyImage.src = src;
        dummyImage.style.visibility = "hidden";
        dummyImage.onload = () => {
            var _a, _b;
            document.body.appendChild(dummyImage);
            const { clientWidth, clientHeight } = dummyImage;
            dummyImage.remove();
            if (imageRef.current) {
                const containerWidth = ((_a = imageRef.current.parentElement) === null || _a === void 0 ? void 0 : _a.clientWidth) || 1;
                const containerHeight = ((_b = imageRef.current.parentElement) === null || _b === void 0 ? void 0 : _b.clientHeight) || 1;
                if (clientWidth / clientHeight < containerWidth / containerHeight) {
                    setHeight(containerHeight);
                    setWidth((containerHeight * clientWidth) / clientHeight);
                }
                else if (clientWidth / clientHeight >
                    containerWidth / containerHeight) {
                    setHeight((containerWidth * clientHeight) / clientWidth);
                    setWidth(containerWidth);
                }
                else {
                    setHeight(containerHeight);
                    setWidth(containerWidth);
                }
            }
        };
    }, [imageRef, setHeight, src, setWidth]);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("style", null, `.roamjs-image-preview-img {
  cursor: pointer;
}

.roamjs-image-preview-portal {
    z-index: 2100;
}
.roamjs-image-preview-portal .bp3-dialog {
    position: absolute;
    top: 32px;
    bottom: 32px;
    left: 32px;
    right: 32px;
    width: unset;
    background-color: transparent;
    box-shadow: none;
    align-items: center;
    justify-content: center;
}

.roamjs-image-preview-portal img {
  background-color: white;
}`),
        react_1.default.createElement(core_1.Dialog, { isOpen: !!src, onClose: onDialogClose, portalClassName: "roamjs-image-preview-portal", style: { paddingBottom: 0 } },
            react_1.default.createElement("img", { src: src, ref: imageRef, style: { height, width } }))));
};
exports.ID = "roamjs-image-preview";
if (process.env.CLIENT_SIDE) {
    react_dom_1.default.hydrate(react_1.default.createElement(ImagePreview, null), document.getElementById(exports.ID));
}
const render = (dom) => {
    const { document } = dom.window;
    const { head, body } = document;
    const imgs = document.querySelectorAll(".roam-block img");
    if (imgs.length) {
        imgs.forEach((img) => img.classList.add("roamjs-image-preview-img"));
        const container = document.createElement("div");
        container.id = exports.ID;
        container.innerHTML = server_1.default.renderToString(react_1.default.createElement(ImagePreview, null));
        body.appendChild(container);
        util_1.ensureBlueprint(document, head);
        util_1.ensureReact(document, head);
        util_1.ensureScript("image-preview", {}, document, head);
    }
};
exports.render = render;
exports.default = ImagePreview;
