import { JSDOM } from "jsdom";
import { TreeNode } from "roam-client";
export declare type HydratedTreeNode = Omit<TreeNode, "children"> & {
    references: {
        title: string;
        uid: string;
    }[];
    children: HydratedTreeNode[];
};
export declare type RenderFunction = (dom: JSDOM, props: Record<string, string[]>, context: {
    convertPageNameToPath: (s: string) => string;
    references: {
        title: string;
        node: HydratedTreeNode;
    }[];
    pageName: string;
}) => void;
export declare const ensureReact: (document: Document, head?: HTMLHeadElement) => void;
export declare const ensureBlueprint: (document: Document, head?: HTMLHeadElement) => void;
export declare const ensureScript: (id: string, componentProps: Record<string, unknown>, document: Document, head?: HTMLHeadElement) => void;
